/*
 *   Copyright © 2009 Fredrik Höglund <fredrik@kde.org>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public License
 *   along with this library; see the file COPYING.LIB.  If not, write to
 *   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *   Boston, MA 02110-1301, USA.
 */

#ifndef STRIPPEDFOLDERVIEW_H
#define STRIPPEDFOLDERVIEW_H

#include <QBasicTimer>
#include <QWidget>

#include <KActionCollection>
#include <KUrl>
#include <QGraphicsWidget>
#include <QGraphicsSceneContextMenuEvent>
#include <QGraphicsSceneDragDropEvent>

namespace Plasma {
    class Applet;
    class FrameSvg;
    class BusyWidget;
}

class KDirModel;
class KFileItemDelegate;
class KFilePlacesModel;
class KFilePreviewGenerator;
class KNewMenu;
class KFileItemActions;
class QItemSelectionModel;
class QModelIndex;
class ProxyModel;
class IconView;

class StrippedFolderView : public QGraphicsWidget
{
    Q_OBJECT
 
public:
    StrippedFolderView(QGraphicsWidget *parent, const KUrl &url, QSize iconSize = QSize());
    ~StrippedFolderView();

private:
	QSize gridSize() const;
	QSize iconSize() const;
	
private slots:
    void activated(const QModelIndex &index);
	
private:
    IconView *m_iconView;
    KDirModel *m_dirModel;
    ProxyModel *m_model;
    KFileItemDelegate *m_delegate;
    QItemSelectionModel *m_selectionModel;
    KFilePreviewGenerator *m_previewGenerator;
    KUrl m_url;
	QSize m_size;
};

#endif

